/*
 *  vector.h
 *  
 *
 *  Created by Ricky Reusser on doublehu Nov 13 2003.
 *  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
 *
 */

#include <iostream>
#include <math.h>

using namespace std;

#ifndef __Vector__
    #define __Vector__
    class Vector{
    public:
        double x,y,z;
        Vector() {x=0;y=0;z=0;}
        Vector (double a, double b, double c){x=a;y=b;z=c;}
        void output(const char name[]){
            cout << name << " = <" << x << "," << y << "," << z << ">" << endl;
        }
        void output(){
            cout << "<" << x << "," << y << "," << z << ">" << endl;
        }
        Vector operator + (Vector param){
            return Vector(x + param.x, y+param.y, z+param.z);
        }
        Vector operator- (Vector param){
            return Vector(x-param.x, y-param.y, z-param.z);
        }
        Vector operator* (double param){
            return Vector(x*param,y*param,z*param);
        }
        Vector operator/ (double param){
            return Vector(x/param,y/param,z/param);
        }
        Vector operator* (Vector param){
            return Vector(x*param.x,y*param.y,z*param.z);
        }
        Vector operator/ (Vector param){
            return Vector(x/param.x,y/param.y,z/param.z);
        }
        Vector operator+= (Vector param){
            x += param.x;
            y += param.y;
            z += param.z;
            return *this;
        }
        Vector operator-= (Vector param){
            x -= param.x;
            y -= param.y;
            z -= param.z;
            return *this;
        }
        Vector operator*= (Vector param){
            x *= param.x;
            y *= param.y;
            z *= param.z;
            return *this;
        }
        Vector operator/= (Vector param){
            x /= param.x;
            y /= param.y;
            z /= param.z;
            return *this;
        }
        Vector operator+= (double param){
            x += param;
            y += param;
            z += param;
            return *this;
        }
        Vector operator-= (double param){
            x -= param;
            y -= param;
            z -= param;
            return *this;
        }
        Vector operator*= (double param){
            x *= param;
            y *= param;
            z *= param;
            return *this;
        }
        Vector operator/= (double param){
            x /= param;
            y /= param;
            z /= param;
            return *this;
        }
        double length(){
            return sqrt(x*x+y*y+z*z);
        }
        Vector& normalize(){
            double l = sqrt(x*x+y*y+z*z);
            x /= l;
            y /= l;
            z /= l;
            return *this;
        }
        Vector& pseudonormalize(){
            double eps = 1e-13;
            double l = sqrt(x*x+y*y+z*z);
            x /= l+eps;
            y /= l+eps;
            z /= l+eps;
            return *this;
        }
        Vector norm(){
            Vector Out;
            double l = sqrt(x*x+y*y+z*z);
            Out.x = x/l;
            Out.y = y/l;
            Out.z = z/l;
            return Out;
        }
        Vector pseudonorm() {
            double eps = 1e-13;
            Vector Out;
            double l = sqrt(x*x+y*y+z*z);
            Out.x = x/(l+eps);
            Out.y = y/(l+eps);
            Out.z = z/(l+eps);
            return Out;
        }
        Vector& operator = (double B) {
            x = B;
            y = B;
            z = B;
            return *this;
        }
    };
    
    Vector operator * (double A, Vector B) {
        return B*A;
    }
	
    Vector vnormalize(Vector A){
		Vector B = A;
		double l = B.length();
		B /= l;
		return B;
	}
	
    Vector vcross(const Vector va, const Vector vb){
        Vector temp;
        temp.x = va.y*vb.z - va.z*vb.y;
        temp.y = va.z*vb.x - va.x*vb.z;
        temp.z = va.x*vb.y - va.y*vb.x;
        return temp;
    }
    double vdot(const Vector va, Vector vb){
        return (va.x*vb.x + va.y*vb.y + va.z*vb.z);
    }
    void output(const Vector a){
        cout << "<" << a.x << "," << a.y << "," << a.z << ">\n";
    }
    void output(const Vector a, const char name[]){
        cout << name << " = <" << a.x << "," << a.y << "," << a.z << ">\n";
    }
    void output(const double a, const char name[]){
        cout << name << " = " << a << "\n";
    }
    Vector Vect(const double a, const double b, const double c){
        Vector temp (a,b,c);
        return temp;
    }
#endif
